function [ f ] = chain_objective( x, param )
% implements the chain objective function for the chain with rigid links,
% i.e. contributions to the energy only from gravitation
% assumes x is ordered as x = [y1, z1, ..., yN, zN]

% the z values are every second value of x
f = param.m * param.g * sum(x(2:2:end));

end

