
% exercise 8
clear;
close all;
clc;

% Number of mass points
N = 23;

% Chain end points
param.xi = [-2 1];  % initial (y1, z1)
param.xf = [ 2 1];  % final   (yN, zN)

% Definining constants in a structure
param.L = 5;
param.m = 0.2;
param.g = 9.81;
param.N = N;

% Initial guess: linear interpolation between the tips
y = linspace(param.xi(1), param.xf(1), N)';
z = linspace(param.xi(2), param.xf(2), N)';

% Eliminate the tips from the decision variables and stack them together
x = reshape([y(2:end-1) z(2:end-1)].',2*(N-2),1);

% create function handles with only x as input
% (param substituted with above values)
chain_obj = @(x) chain_objective(x,param);
chain_con = @(x) chain_constraints(x,param);

opts = optimoptions('fmincon');
% we need to increase this from the default value
opts.MaxFunEvals = 20000; 

% optimize
[sol, ~, ~, output, ~, gradsol, ~] = fmincon(chain_obj,x,[],[],[],[],[],[],chain_con, opts);
 
% Plot solution
plot_chain(sol, param);

% Check constraints at solution
[C, Ceq] = chain_con(sol);

disp(' ')
disp('Maximum constraint violation at solution:')
disp(max(abs(Ceq)))
% 
disp('Size of Jacobian:')
[F, J] = i_trick(@chain_eqconstraints,sol,param);
disp(size(J))

disp('Rank of Jacobian:')
disp(rank(J));