%  exercise 4.4
% alternate version using casadi and ipopt

clear;
close all;
clc;
import casadi.*

% Number of mass points
N = 23;

% Chain end points
xi = [-2 1];  % initial (y1, z1)
xf = [ 2 1];  % final   (yN, zN)

% Definining constants
L = 5;
m = 0.2;
g = 9.81;
Li = L / (N+1);

% Initial guess: linear interpolation between the tips


yin = linspace(xi(1), xf(1), N+2)';
% there neends to be some difference z so ipopt is able to solve
zin = linspace(xi(2), xf(2)-.1, N+2)';
% remove the tipps
yin = yin(2:end-1); zin = zin(2:end-1);

opti = casadi.Opti();
y = opti.variable(N);
z = opti.variable(N);

opti.minimize(m*g*sum(z))

% left side constraint
opti.subject_to( (xi(1)-y(1))^2 + (xi(2)-z(1))^2 - Li^2 == 0 )
% intermediate constraints
opti.subject_to( diff(y).^2 + diff(z).^2 - Li^2 == 0 )
% right side constraint
opti.subject_to( (xf(1)-y(end))^2 + (xf(2)-z(end))^2 - Li^2 == 0 )

% Nfix = round(N/2-2);
% opti.subject_to( y(Nfix) == 0 )
% opti.subject_to( z(Nfix) == .6 )

% opti.subject_to( y(1) == xi(1)+Li )
% opti.subject_to( z(1) == xi(2) )


opti.set_initial(y, yin)
opti.set_initial(z, zin)

% p_opts = struct('expand',true);
% s_opts = struct('max_iter',1e4,'print_level',5);
% s_opts = struct('hessian_approximation','limited-memory');
% opti.solver('ipopt', p_opts, s_opts);
opti.solver('ipopt')
% opti.solver('worhp')
sol = opti.solve();

yopt = sol.value(y);
zopt = sol.value(z);
 
% Plotting
param.xi = xi;
param.xf = xf;
plot_chain(yopt, zopt, param);


Jg = full( opti.value(jacobian(opti.g,opti.x)));